<template>
            <div
            class=" d-flex flex-column flex-grow-0 justify-content-center align-items-center"
          >
            <div class="d-flex justify-content-center align-items-center marc" :class="setSize">
              <font-awesome-icon v-if="!userImage" color="grey" icon="user"/>
              <img v-else :class="setSize"  :src="userImage" alt="user image">
            </div>
          <slot name="underImage">
          </slot>
          </div>
</template>
<script>
export default {
  props:["user","size"],
  created:function(){
    this.$socket.on('resUserImage',data=>{
      if(this.user.id==data.userId){
        this.userImage=this.image(data.image)
      }
    })
  },
  mounted:function(){
    this.$socket.emit('reqUserImage',{
      user:this.user,
      token:this.token
    })
  },
  data(){
    return{
      userImage : null,
      token: localStorage.getItem("jwt"),
    }
  },
  computed:{
    setSize:function(){
      var classes=null;
      switch(this.size){
        case "lg" : return "sizeLg marcLg"
        break
        case "sm" : return "sizeSm marcSm"
        break
      }
    }
  },
  methods:{
    image: (cover) => {
      var bufer = new Buffer.from(cover);
      var imageToB64 = bufer.toString("base64");
      return "data:image/jpeg;base64, " + imageToB64;
    },
  }
}
</script>
<style scoped>
  .sizeLg{
    font-size: calc(4vw + 4vh);
    width: calc(2vw + 2vh);
    height: calc(2vw + 2vh);
  }
  .marcLg{
    width: calc(4.5vw + 4.5vh);
    height: calc(5.5vw + 5.5vh);
  }
  .sizeSm{
   font-size: calc(1.8vw + 1.8vh);
   width: calc(1.8vw + 1.8vh);
   height: calc(1.8vw + 1.8vh);
  }
  .marcSm{
    width: calc(2vw + 2vh);
    height: calc(2.4vw + 2.4vh);

  }
  .marc{
    background-color: lightgray;
    border-radius: 100px / 60px;
  }
  img{
    border-radius: 50px;
    transform: scale(0.9);
  }
</style>


